/* EPS Conduits (C) 2014-2017 Stephane Charette <stephanecharette@gmail.com>
 * $Id: Connection.hpp 2167 2017-03-01 12:10:04Z stephane $
 * See license.txt.
 */

#pragma once

#include "common.hpp"
#include "NetBuffer.hpp"
//#include <boost/asio/buffer.hpp>
#include <string>
#include <array>


namespace EPS
{
	class Hull;

	/// Base class for TCP and UDP connections between peer devices. @see EPS::TCPConnection @see EPS::UDPConnection
	class Connection
	{
		public:

			/// Constructor.
			Connection(void);

			/// Destructor.
			virtual ~Connection(void);

			/// Set various socket options.
			virtual void set_socket_options(void) = 0;

			size_t				id;		///< unique connection id, helpful when logging connection-specific messages
			std::string			name;	///< convenient name to use for logging
			UUID				uuid;	///< corresponding UUID for this peer connection @see EPS::Tracker which uses the uuid as the key
			Hull			&	hull;	///< for convenience, keep a reference to the hull that created this connection
			EC					ec;		///< boost error code
	};
}
